////////////////
//  CONSTS.H  //
////////////////

#ifndef TAD_CONSTS
#define TAD_CONSTS

//Afegit Toni
#if !defined(__FLAT__)
#define MAXINT      0x7FFF
#else    /* defined __FLAT__ */
#define MAXINT      0x7FFFFFFF
#endif
#define MAXFLOAT    3.37E+38F


#define SCAPECONTROL

//// Some general values for configuring the behavior of the general program////

#define MAXNUMTICKS	4	//Maxim Number of TICKS to Save in Variable History

#define MAXNUMSYSTEMS      4  // Maxim Number of Cooperative Systems.
#define MAXNUMDATAFACTS   45 // Mida de la Base de Coneixement
#define MAXOPPOSITES       5  // Maxim n de coneixements del sistema de reacci  
#define MAXNUMRESERVEDVARIABLES 5 //Maxim numero de aniuaments dintre de les regles

#define PERTURBATION_RATE .3  // Perturbation Rate 0..1 for Numeric Values.

 
enum NP_MODE { NPprobabilistic=1, NPfuzzy, NPconservative,
                         PNprobabilistic, PNfuzzy, PNconservative,
                         Everyone };

#define NUMRANDOMVECTORS   0
#define RANDOMVECTORLONG   1  // canviat 276  A     // Looking for an Odd Number.

#define DESCRIPTIONSIZE 15

//////////////////////////////////////////////////////////////////////////////

#define absolut(a) (((a) >= (0)) ? (a) : (-a))

#define __MINMAX_DEFINED
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#define min(a,b)    (((a) < (b)) ? (a) : (b))

#define round(a)    (((a) >= 0 ) ? (int) ((float) (a) + .5) : (int) ((float) (a) - .5))
#define aha(a, b)   (((a) < 0 || (a) >= (b)) ? error ("\nMatrix Error") : (a))
#define aa(a)      (((a) < 0) ? error ("\nMatrix Error") : (a))

#define Count(A, B, C) for ((A)=(B); A<C; (A)++)

#define FACT(a)   DATAFACT a;a.ConstructorDATAFACT(); 
#define RESULT(a)  DATAFACTRESULT a; a.ConstructorDATAFACTRESULT();
/////////////////////////////////////////////////////////////////////////////
/////////////////  N, P  qualifications  ////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

#define FULL               1.0
#define VERYHIGH           .95
#define HIGH               .85
#define NOTVERYHIGH        .75
#define NORMAL             .65
#define NOTVERYLOW         .45
#define LOW                .35
#define VERYLOW            .18
#define NUL                0.0
#define HIGHPRESTIGE       .85
#define NORMALPRESTIGE     .65
#define LOWPRESTIGE        .35
#define HIGHNECESSITY      .65
#define NORMALNECESSITY    .35
#define LOWNECESSITY       .18
/////////////////////////////////////////////////////////////////////////////

/////////////////////// Kinds of Datafacts //////////////////////////////////



enum DATAFACTTYPE {NOTYPE=0, DETECTION, DIAGNOSTIC, ACTION, 